class DEVAPI {
    // html5+ 对象
    HTML5_PLUS_REFLECT_BROADCASTRECEIVER = "io.dcloud.feature.internal.reflect.BroadcastReceiver" // html5+ 创建数据监听api
    HTML5_PLUS_CONTENT_INTENT = "android.content.Intent" // html5+ 初始化上下文
    HTML5_PLUS_CONTENT_INTENTFILTER = "android.content.IntentFilter" // html5+ 暴露接口
    HTML5_PLUS_RUNTIME_MAIN_ACTIVITY = null // 设备活动
    HTML5_PLUS_KEY_DOWN = "com.aoro.poc.key.down" // 按钮被按下
    // 广播对象
    POC_KEY_DOWN_OBJ = null

    // 扫描对象
    SCANOBJ = {
		ACTION_SCAN_RESULT : "com.action.SCAN_RESULT",
        SCAN_SERVICE: "com.action.INIT_SCAN", // 扫描权限
        SCAN_RESULT: "com.action.SCAN_RESULT", // 扫描结果
        SCAN_BEGIN: "com.action.START_SCAN", // 开始扫描
        SCAN_END: "com.action.STOP_SCAN", // 关闭扫描
    }

    // RFID 对象
    RFID_SDK_WX = null
    // 0红外扫描  1 RFID
    TYPE_DEV_JQHWGEVIQUWVILBE = 0
    // RFID 时间
    RFIDIntervalTime = null
    // RFID type 
    ISRFIDOPEN = false

    constructor() {}

    // 监听按钮被按下--
    initDevAPI() {
		//this.initRFID() // RFID 初始化
		        // 意图
		        let HTML5_PLUS_CONTENT_INTENT_CLASS = plus.android.importClass(this.HTML5_PLUS_CONTENT_INTENT);
		        this.HTML5_PLUS_RUNTIME_MAIN_ACTIVITY = plus.android.runtimeMainActivity(); // HTML5_PLUS 获取 activity
		
		        // 权限
		        let intentServer = new HTML5_PLUS_CONTENT_INTENT_CLASS(this.SCANOBJ.SCAN_SERVICE);
		        this.HTML5_PLUS_RUNTIME_MAIN_ACTIVITY.sendBroadcast(intentServer);
		
		        // HTML5_PLUS 创建数据监听函数
		        this.POC_KEY_DOWN_OBJ = plus.android.implements(
		            this.HTML5_PLUS_REFLECT_BROADCASTRECEIVER, {
		                onReceive: (context, intent) => {
		                  
		                    // 红外扫描结果
		                    if (intent.getAction() === this.SCANOBJ.SCAN_RESULT) {
		                        let _data_ = intent.getByteArrayExtra("scanContext")
								let codeStr = this.byteToString(_data_)
		                        console.log(`回调数据:${codeStr}`)
		                        uni.$emit('scancodemsg', {
		                            msg: _data_
		                        })
		                    }
		
		                    // 按钮按下
		                    if (intent.getAction() === this.HTML5_PLUS_KEY_DOWN && this
		                        .TYPE_DEV_JQHWGEVIQUWVILBE ===
		                        0) {
		                        // 调用扫描头
		                        console.log("按键被按下，开始扫描")
		                        let intents = new HTML5_PLUS_CONTENT_INTENT_CLASS(this.SCANOBJ
		                            .SCAN_BEGIN); // 红外扫描开启
		                        this.HTML5_PLUS_RUNTIME_MAIN_ACTIVITY.sendBroadcast(intents);
		                    } else if (intent.getAction() === this.HTML5_PLUS_KEY_DOWN &&
		                        this.TYPE_DEV_JQHWGEVIQUWVILBE === 1) {
		                        console.log("按键被按下，开启RFID")
		                        this.ISRFIDOPEN = !this.ISRFIDOPEN
		                        if (this.ISRFIDOPEN === true) {
		                            console.log("开启RFID")
		                            this.RFIDStartInventory()
		                        } else {
		                            console.log("关闭RFID")
		                            this.RFIDStopInventory()
		                        }
		                    }
		                }
		            }
		        );
		        let IntentFilter = plus.android.importClass(this.HTML5_PLUS_CONTENT_INTENTFILTER); // 暴露接口对象
		        let filter = new IntentFilter();
				filter.addAction(this.SCANOBJ.ACTION_SCAN_RESULT); // 红外 扫描结果，广播
		        filter.addAction(this.HTML5_PLUS_KEY_DOWN); // 按钮对按钮，广播
		        filter.addAction(this.SCANOBJ.SCAN_RESULT); // 红外 扫描结果，广播
		        this.HTML5_PLUS_RUNTIME_MAIN_ACTIVITY.registerReceiver(this.POC_KEY_DOWN_OBJ, filter); // 注册功能开始
	}
	
	byteToString(arr) {
				if(typeof arr === 'string') {
					return arr;
				}
				var str = '',
					_arr = arr;
				for(var i = 0; i < _arr.length; i++) {
					var one = _arr[i].toString(2),
						v = one.match(/^1+?(?=0)/);
					if(v && one.length == 8) {
						var bytesLength = v[0].length;
						var store = _arr[i].toString(2).slice(7 - bytesLength);
						for(var st = 1; st < bytesLength; st++) {
							store += _arr[st + i].toString(2).slice(2);
						}
						str += String.fromCharCode(parseInt(store, 2));
						i += bytesLength - 1;
					} else {
						str += String.fromCharCode(_arr[i]);
					}
				}
				return str;
			}

}

export {
    DEVAPI
}
